<?php
require_once(ROOTDIR."/include/database/class.ServerQueries.php");
require_once(ROOTDIR."/include/objects/class.Server.php");

?>
<script src="javascript/ajax.js" language="javascript" type="text/javascript"></script>
<script src="javascript/functions.js" language="javascript" type="text/javascript"></script>
<script type="text/javascript">
function formVerify() {
  var errorFound = false;
  var alertMessage = "";

  // Validate IP
  var regex = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
  var serverIp = document.getElementById("serverIp").value;
  if(!serverIp.match(regex)) {
    alertMessage += "Server IP is invalid.\n\r";
    errorFound = true;
  }

  // Validate Port
  var regex = /^\d{1,8}$/;
  var serverPort = document.getElementById("serverPort").value;
  if(!serverPort.match(regex)) {
    alertMessage += "Server Port is invalid.\n\r";
    errorFound = true;
  }

  // We have an error, do not submit the form
  if(errorFound) {
    alert(alertMessage);
    return false;
  }

  return true;
}

function deleteVerify(serverId, serverName) {
  if(confirm("Do you really want to delete "+serverName+"?")) {
    document.getElementById("deleteServer"+serverId).submit();
  }
}
</script>
<?php
// Only those with full privs can remove or add servers to the list
if($fullPower) {

$serverQueries = new ServerQueries();

$error = false;

// If this is set, then that means a server is being added
if(isset($_POST['submitAdd'])) {

  // TODO: Verify that the server can be connected to

  $newServerId = $serverQueries->addServer($_POST['serverName'], $_POST['serverIp'], $_POST['serverPort'], $_POST['serverRcon'], $_POST['serverType']);

  if($newServerId < 0) {
    $error = true;
  }
}

// If a server is being deleted
if(isset($_POST['deleteServer'])) {
  $serverQueries->deleteServer($_POST['serverId']);
}
// Get list of server objects
$servers = $serverQueries->getServers();
?>
<br/>
<br/>
<div class="tborder">
  <div id="tableHead">
    <div><b>Server Management List</b></div>
  </div>
  <table id="serverManagementTable" class="bordercolor" width="100%" cellspacing="1" cellpadding="5" border="0" style="margin-top: 1px;">
    <tr>
      <th class="colColor1" width="1%" nowrap>Server ID</th>
      <th class="colColor2" width="1%" nowrap>Server Name</th>
      <th class="colColor1" width="1%" nowrap>IP</th>
      <th class="colColor2" width="1%" nowrap>Port</th>
      <th class="colColor1" width="1%" nowrap>Type</th>
      <th class="colColor2" width="1%" nowrap>Current RCON Password</th>
      <th class="colColor1" width="1%" nowrap>New RCON Password</th>
      <th class="colColor2" width="1%" nowrap>Save</th>
      <th class="colColor1" width="1%" nowrap>Delete</th>
    </tr>
    <?php foreach($servers as $server) {
          ?>
          <tr>
            <td class="colColor1" width="1%" nowrap><?=$server->getId()?></td>
            <td class="colColor2" width="1%" nowrap><input type="text" id="serverName:<?=$server->getId()?>" name="serverName:<?=$server->getId()?>" value="<?=$server->getName()?>" size="40" maxlength="128"/></td>
            <td class="colColor1" width="1%" nowrap><input type="text" id="serverIp:<?=$server->getId()?>" name="serverIp:<?=$server->getId()?>" value="<?=$server->getIp()?>" size="20" maxlength="16"/></td>
            <td class="colColor2" width="1%" nowrap><input type="text" id="serverPort:<?=$server->getId()?>" name="serverPort:<?=$server->getId()?>" value="<?=$server->getPort()?>" size="10"/></td>
            <td class="colColor1" width="1%" nowrap>
              <select id="serverType:<?=$server->getId()?>" name="serverType:<?=$server->getId()?>">
                <?php if(strtolower($server->getType()) == "cstrike") { ?>
                  <option value="cstrike" selected>CS:S</option>
                <?php }else { ?>
                  <option value="cstrike">CS:S</option>
                <?php }
                      if(strtolower($server->getType()) == "tf2") { ?>
                  <option value="cstrike" selected>TF2</option>
                <?php }else { ?>
                  <option value="tf2">TF2</option>
                <?php }
                      if(strtolower($server->getType()) == "dod") { ?>
                  <option value="dod" selected>DOD:S</option>
                <?php }else { ?>
                  <option value="dod">DOD:S</option>
                <?php } ?>
              </select>
            </td>
            <td class="colColor2" width="1%" nowrap><input type="password" id="currentServerRcon:<?=$server->getId()?>"name="currentServerRcon:<?=$server->getId()?>" value="" maxlength="40"/></td>
            <td class="colColor1" width="1%" nowrap><input type="password" id="serverRcon:<?=$server->getId()?>"name="serverRcon:<?=$server->getId()?>" value="" maxlength="40"/></td>
            <td id="save:<?=$server->getId()?>" class="colColor2" onclick="saveServer('<?=$server->getId()?>');" style="cursor:pointer;">
            <img src="images/tick.png"/>
            </td>
            <td class="colColor1" style="cursor:pointer;" onclick="deleteVerify('<?=$server->getId()?>', '<?=$server->getName()?>');">
            <form action="index.php?page=manageServers&adminPage=1" id="deleteServer<?=$server->getId()?>" name="deleteServer<?=$server->getId()?>" method="POST">
              <input type="hidden" name="serverId" id="serverId" value="<?=$server->getId()?>"/>
              <input type="hidden" name="deleteServer" value="1">
              <img src="images/trash-full.png"/>
            </form>
            </td>
          </tr>
    <?php } ?>

    </table>
   </div>
    <br/><br/>

    <!-- This row is for adding a new server -->
    <div class="tborder">
    <div id="tableHead">
      <div><b>Add New Server</b></div>
    </div>
    <form action="index.php?page=manageServers&adminPage=1" method="POST" onsubmit="return formVerify();">
    <table id="newServerTable" class="bordercolor" width="100%" cellspacing="1" cellpadding="5" border="0" style="margin-top: 1px;">
    <tr>
      <td class="colColor1" width="1%" nowrap>Server Name:</td>
      <td class="colColor1" nowrap><input type="text" name="serverName" id="serverName" value="" size="40" maxlength="128"/></td>
    </tr>
    <tr>
      <td class="colColor2" width="1%" nowrap>Server IP:</td>
      <td class="colColor2" nowrap><input type="text" name="serverIp" id="serverIp" value="" size="20" maxlength="16"/></td>
    </tr>
    <tr>
      <td class="colColor1" width="1%" nowrap>Server Port:</td>
      <td class="colColor2" nowrap><input type="text" name="serverPort" id="serverPort" value="27015" size="10"/></td>
    </tr>
    <tr>
      <td class="colColor1" width="1%" nowrap>Server Type:</td>
      <td class="colColor1" nowrap>
        <select id="serverType" name="serverType">
            <option value="cstrike">CS:S</option>
            <option value="dod">DOD:S</option>
        </select>
      </td>
    </tr>
    <tr>
      <td class="colColor2" width="1%" nowrap>Server RCON:</td>
      <td class="colColor2" nowrap><input type="text" name="serverRcon" id="serverRcon" value="" maxlength="40"/></td>
    </tr>
      <td class="colColor1" colspan="2"><input type="submit" name="submitAdd" id="submitAdd" value="Add Server"/></td>

    </tr>
    <?php
      if($error) {
      ?><tr><td class="colColor1" colspan="2"><span class="error">Server Already Exists</span></td></tr><?php
      }
    ?>
  </table>
  </form>
</div>
<h5>Note: You must perform a "Save Configuration" from the "Configuration" page after adding any new servers.</h5>
<?php
}
?>
